let table       = document.querySelector('table');
let taskInput   = document.querySelector('#task-input');
let taskButton  = document.querySelector('#task-button');

table.addEventListener('click' , function(event){
    let target  = event.target;
    if(target.classList.contains('delete')){
        let id  = target.id.substr(7);
        deleteTask(id);
        renderTable();
    }
});

taskButton.addEventListener('click' , addTaskHandler);

taskInput.addEventListener('keyup' , event => {
    if(event.keyCode == 13){
        addTaskHandler();
    }
});

function addTaskHandler(){
    if(taskInput.value == ''){
        return;
    }
    addTask(taskInput.value);
    taskInput.value = '';
    renderTable();
}

function getAllTasks(){
    let tasks   = JSON.parse(localStorage.getItem('tasks'));
    if(!tasks){
        return [];
    }else{
        return tasks;
    }   
}

function addTask(title){
    let tasks   = getAllTasks();
    let id;
    if(tasks.length == 0){
        id      = 1;
    }else{
        id      = tasks[tasks.length - 1].id + 1;
    }    
    tasks.push({id , title});
    localStorage.setItem('tasks' , JSON.stringify(tasks));
}

function deleteTask(id){
    let tasks   = getAllTasks();
    let length  = tasks.length;
    tasks       = tasks.filter(function(task){
        return task.id != id;
    });
    localStorage.setItem('tasks' , JSON.stringify(tasks));
    return tasks.length != length;
}

function renderTable(){
    let tableBody   = document.querySelector('table tbody');
    let tasks       = getAllTasks();
    let html        = '';
    let index       = 1;
    for(task of tasks){
        html += `
        <tr>
            <td>${index}</td>
            <td>${task.title}</td>
            <td><button type="button" class="delete" id="delete-${task.id}">X</button></td>
        </tr>
        `;
        index++;
    }
    tableBody.innerHTML = html;
}

renderTable();